// Led Sensors Driver Lib

#include "LedDriver.h"
#include <string.h>
#include "Main.h"





//------------------------------------------------------
void LedDriver_Init(uint32_t clockpin, uint32_t datapin)
{
	//SetUp pinB10 for Clock
	RCC->APB2ENR |= RCC_APB2ENR_IOLEDEN; 			 // GPIOB Clock ON. Alter function clock ON

		//CLK
	if (clockpin > 7){
//		LED_GPIO->CRH	&= ~(0x03 << (clockpin-8)*4); 	// Clear mode bits 
//		LED_GPIO->CRH	&= ~(0x0C << (clockpin-8)*4);		// 			and CNF bits
		LED_GPIO->CRH	&= ~(0x0F << (clockpin-8)*4);
		LED_GPIO->CRH	|= (0x02 << (clockpin-8)*4);		// Set MODE  to "10" = 2 MHz
		LED_GPIO->BRR = (1 << clockpin);     					//	CLK -> low	
	}else{
		LED_GPIO->CRL	&= ~(0x0F << clockpin*4); 			// Clear mode bits and CNF bits				// 			
		LED_GPIO->CRL	|= (0x02 << clockpin*4);				// Set MODE  to "10" = 2 MHz
		LED_GPIO->BRR = (1 << clockpin*4);     				//	CLK -> low	
	}
	
		//Data
	if (datapin > 7){
		LED_GPIO->CRH	&= ~(0x0f << (datapin-8)*4); 		// Clear mode bits and CNF bits 			
		LED_GPIO->CRH	|= (0x02 << (datapin-8)*4);			// Set Mode  to "10" = 2 MHz
		LED_GPIO->BRR = (1 << datapin*4);     				//	CLK -> low	
	}else{
		LED_GPIO->CRL	&= ~(0x0F << datapin*4); 				// Clear mode bits and CNF bits 			
		LED_GPIO->CRL	|= (0x02 << datapin*4);					// Set Mode  to "10" = 2 MHz
		LED_GPIO->BRR = (1 << datapin*4);     				//	data -> low	
	}
}

// off all LEDs (set Outputs to "1")
//------------------------------------------------------
void LedDriver_Reset(uint32_t clockpin, uint32_t datapin)
{
	uint8_t i;
  
	LED_GPIO->BSRR = (1<< datapin);		//data high
	for (i=0; i < 9; i++){
		Delay_uSec(10);	
		LED_GPIO->BSRR = (1<< clockpin);		//pulse high
		Delay_uSec(10);
		LED_GPIO->BRR = (1<< clockpin);;		//CLK low
		Delay_uSec(10);		
	}
	Delay_uSec(10);		
}

