//LedDriver.h

#ifndef _LEDDRIVER_H_
#define _LEDDRIVER_H_

#include "stm32f10x.h"


#define RCC_APB2ENR_IOLEDEN		RCC_APB2ENR_IOPBEN	//IO port Clock Enable - PortB
#define LED_GPIO			GPIOB

#define LED_CLK1 	    	11		// Clock on Pin PB11
#define LED_DATA1				10		// Data On PB10
#define LED_CLK1_LOW 		GPIOB->BSRR = GPIO_BSRR_BR11;
#define LED_CLK1_HIGH 	GPIOB->BSRR = GPIO_BSRR_BS11;
#define LED_DAT1_LOW 		GPIOB->BSRR = GPIO_BSRR_BR10;
#define LED_DAT1_HIGH 	GPIOB->BSRR = GPIO_BSRR_BS10;


#define LED_CLK2 	    	1
#define LED_DATA2				0
#define LED_CLK2_LOW 		GPIOB->BSRR = GPIO_BSRR_BR1;
#define LED_CLK2_HIGH 	GPIOB->BSRR = GPIO_BSRR_BS1;
#define LED_DAT2_LOW 		GPIOB->BSRR = GPIO_BSRR_BR0;
#define LED_DAT2_HIGH 	GPIOB->BSRR = GPIO_BSRR_BS0;



//-------------------------------------------------------
void LedDriver_Init(uint32_t clockpin, uint32_t datapin);
void LedDriver_Reset(uint32_t clockpin, uint32_t datapin);
void LedDriver_Shift(uint32_t clockpin, uint32_t datapin);


#endif

