// STM32F10X_MD

#include <string.h>
//#include "MyUSART.h"
#include "ssh1106.h"
#include "Main.h"

char str[100];
volatile uint32_t msTicks_200 = 0;

int16_t i;

////////////////////////////////////////////////////////////////////////
int main()
{
	// SetUP SysTimer
	SysTick_Config(SystemCoreClock / 5);      // Configure SysTick to generate an interrupt (max 2^24 tiks)
	
	__enable_irq ();	//Enable Global interrupt
	
	Delay_200mS(1);
	//SetUp pinC13 for LED
	RCC->APB2ENR 	|= RCC_APB2ENR_IOPAEN | RCC_APB2ENR_IOPBEN | RCC_APB2ENR_IOPCEN ;
	GPIOC->CRH	&= ~GPIO_CRH_CNF13;	// 00 - GPIO output, Push-Pull 
	GPIOC->CRH 	|= GPIO_CRH_MODE13_1;	// MODE10 = Max Speed 2MHz	
	
	Delay_200mS(1);
	SSH1106_Init();
	SSH1106_UpdateDisplay();
	Delay_200mS(1000);	

	SSH1106_ClearDisplay();
	SSH1106_UpdateDisplay();
	LcdGotoXYFont(4,1);
	LCD_Print(FONT_1X, "IgiCOM");
	SSH1106_UpdateDisplay();
	LcdGotoXYFont(2,4);
	LCD_Print(FONT_2X, "DISPLAY");				
	SSH1106_UpdateDisplay();
	LcdGotoXYFont(2,7);
	LCD_Print(FONT_2X, "TEST...");				
	SSH1106_UpdateDisplay();

	
	while (1){
			
	} //do nothing		


}

// utils
//------------------------------------------------------
void Delay_uSec(uint32_t uSec)
{
	uint8_t i;
	while (uSec > 0){
		for (i=0; i<36; i++){
			__nop();		
		}		
		uSec--;
	}

}

//---------------------------------------------------------------
void Delay_200mS( uint32_t Val) 
{
	msTicks_200 = Val;
	while(msTicks_200 > 0){;}
}

//---------------------------------------------------------------
void SysTick_Handler(void)
{
	
	if(GPIOC->IDR & GPIO_IDR_IDR13){
		GPIOC->BSRR |= GPIO_BSRR_BR13;
	}else{
		GPIOC->BSRR |= GPIO_BSRR_BS13;
	}

	if (msTicks_200 > 0){
		msTicks_200--;			// decrement at each 200mS 
	}
	
}



