
#include <string.h>
#include "MyUSART.h"

char RxBuff[USART_MAX_BUFF];
char TxBuff[USART_MAX_BUFF];

char TmpBuff[USART_MAX_BUFF];
uint16_t vCRC; 
char* vRxPointer;
char* vTxPointer;
uint8_t vRxCNT;
uint8_t vTxCNT; 




void USART_Init(void)
{
	uint32_t temp;
	//RCC->APB1ENR |= RCC_APB1ENR_USART2EN | RCC_APB1ENR_USART3EN; // And Usart 2
	RCC->APB2ENR |=  RCC_APB2ENR_AFIOEN | RCC_APB2ENR_IOPAEN // | RCC_APB2ENR_IOPBEN 			 // GPIOA & GPIOB Clock ON. Alter function clock ON
								 |	RCC_APB2ENR_USART1EN ; //ENABLE USART 1 

	
	USART1->BRR = (468<<4)|0x0C;		// Baudrate for 9600 on 72Mhz
	USART1->CR1  |= USART_CR1_UE | USART_CR1_TE | USART_CR1_RE | USART_CR1_RXNEIE; // USART1 ON, TX ON, RX ON
	
	//TX1 on PINA9
	GPIOA->CRH	&= ~(GPIO_CRH_CNF9 | GPIO_CRH_MODE9); 				// Clear CNF and Mode bit 9 
	GPIOA->CRH	|= GPIO_CRH_CNF9_1;				// Set CNF bit 9 to 10 - AFIO Push-Pull
	GPIOA->CRH	|= GPIO_CRH_MODE9_0;				// Set MODE bit 9 to Mode 01 = 10MHz
	//RX1 on PINA10	
	GPIOA->CRH	&= ~(GPIO_CRH_CNF10 | GPIO_CRH_MODE10);	// Clear CNF and Mode:(00 = input) bit 10
	GPIOA->CRH	|= GPIO_CRH_CNF10_1;	// Set CNF bit 10 to "10" = PullUp		
	GPIOA->BSRR = GPIO_BSRR_BS10;     // Enable PULL UP
	
	GPIOA->CRH &= ~GPIO_CRH_CNF8;			// Clear CNF bit 8 "00" - Push/Pull
	GPIOA->CRH |= GPIO_CRH_MODE8_1;
	GPIOA->CRH &= ~GPIO_CRH_MODE8_0;	//Mode: "10" - Output 2 MHz
	GPIOA->BSRR = GPIO_BRR_BR8;     	//Rx mode	
	
	temp = USART1->SR;	//Clear pending
	temp = USART1->DR;
	vRxCNT = 0;
	vTxCNT = 0;
	
	NVIC_ClearPendingIRQ(USART1_IRQn);

	//UART INT ON
	NVIC_EnableIRQ (USART1_IRQn);

};


//---------------------------------------------------------------
void USART1_IRQHandler(void)
{
	uint16_t data;
  volatile unsigned int IIR;
	IIR = USART1->SR;	// Get status flags
	
	if (IIR & USART_SR_RXNE)	{				// read interrupt		
		data = USART1->DR;
		if(data == 0x23){		//'#' - begin of frame
				vRxCNT = 0;	
				return;				// exit
		} 
		
		if(data == 0x0d){		//<CR> - end of frame
			if(vRxCNT < 10){
				vRxCNT = 0;			// Too Short Frame	
			}else{
				//USART1_ProccessFrame();
			}	
			return;			// exit
		}
		
		RxBuff[vRxCNT++] = data;
	}
	
}

// Decode and execute frame 
//-------------------------------------------------------------------------------
void USART1_ProcessFrame(void)
{

}

/*
// 
//-------------------------------------------------------------------------------
void USART2_IRQHandler (void)
{
	uint16_t temp;
  volatile unsigned int IIR;
	IIR = USART2->SR;	// Get status flags
	if (IIR & USART_SR_RXNE)	{				// read interrupt		
		temp = USART2->DR;
		USART1->DR = temp;		//forward 
		if (Usart2_RxIndex < USART_MAX_BUFF){
			Usart2_RxBuff[Usart2_RxIndex++] = temp;
		}
		USART2->CR1 |= USART_CR1_IDLEIE;
	}
	
	if (IIR & USART_SR_IDLE)	{				// Line is in the IDLE
		temp = USART2->DR;		//reset flag
		USART2->CR1 &= ~USART_CR1_IDLEIE;	//CLEAR_BIT IDLE flag
		if (Usart2_RxIndex > 0){
			memcpy(Card1_Buff, Usart2_RxBuff, Usart2_RxIndex);
			Card1_Lenght = Usart2_RxIndex;	
			Usart2_RxIndex = 0;	
		}		
	} 
}
*/

/*
//
//---------------------------------------------------------------------------------
void USART3_IRQHandler (void)
{
	uint16_t temp;
  volatile unsigned int IIR;
	IIR = USART3->SR;	// Get status flags
	if (IIR & USART_SR_RXNE)	{				// read interrupt		
		temp = USART3->DR;
//		USART3->DR = temp;		//forward 
		if (Usart3_RxIndex < USART_MAX_BUFF){
			Usart3_RxBuff[Usart3_RxIndex++] = temp;
		}
		USART3->CR1 |= USART_CR1_IDLEIE;
	}
	
	if (IIR & USART_SR_IDLE)	{				// Line is in the IDLE
		temp = USART3->DR;		//reset flag
		USART3->CR1 &= ~USART_CR1_IDLEIE;	//CLEAR_BIT IDLE flag
		if (Usart3_RxIndex > 0){
			memcpy(Card2_Buff, Usart3_RxBuff, Usart3_RxIndex);
			Card2_Lenght = Usart3_RxIndex;	
			Usart3_RxIndex = 0;	
		}		
	} 
	
	// transmit
	if (IIR & USART_SR_TXE) {					//transmit empty
      USART3->SR &= ~USART_SR_TXE;	          // clear interrupt
//			USART3->DR = USART3->DR;				// forward to USART1

    }
};

*/

