#ifndef MY_USART_LIB_H
#define MY_USART_LIB_H



#include "stm32f10x.h"


#define USART_MAX_BUFF	128

//------------------------------------------------------
//  RS/ITU-485 USART  Interface 
//	Subrotines
//	Calmicov Igor <igor.calmicov@gmail.com>
//------------------------------------------------------

#define	CRC_POLINOM			0x8F57		//CRC16 Polinom

// Commands
#define SendIDCommand	   		0x01	// Send ID  (not implemented yet)
#define ReadStateCommand		0x02 
//#define OpenDoorCommand		0x04

#define SetResOutCommand		0x08	// Reserved Output

#define SetOutputCommand		0x09	// On Outputs
#define ClearOutputCommand	0x0A	// Off Outputs
#define ResetCommand				0x0B	// Reset power (MASK)

//#define SesionTimeOutCommand	0x20	//Max time for open sesion
//#define LockReleaseTimeCommand	0x21	//time for open

#define ReadTempCommand			0x40	//Read Temperature
#define ReadVoltageCommand		0x41	//Read Voltage
//#define ReadBatteryCommand		0x42	//Read Battery Status

// Pin's 
//RS485
#define	TxSEL			PA8			// RS485 Direction
#define	TxD				PA9			// USART output 
#define	RxD				PA10		// USART input

//#define RCC_APB2ENR_IOUSARTEN		RCC_APB2ENR_IOPAEN	//IO port Clock Enable - PortA
//#define USART_GPIO			GPIOA

#define TxSEL_LOW 			GPIOA->BSRR = GPIO_BSRR_BR8;
#define TxSEL_HIGH 			GPIOA->BSRR = GPIO_BSRR_BS8;


void USART_Init(void);
#endif
